import greenfoot.*;

/**
 * a class used to represent creation of wave pulses using the world background with no radial limit
 * 
 * Author: danpost
 * Version: 1.0.0
 */
public class Medium0 extends World
{
    final static int[][] parts = { {0,0,1}, {0,1,0}, {1,0,0}, {0,1,1}, {1,0,1}, {1,1,0}, {1,1,1} };
    static int color = 6;
    
    int freq = 3;
    int[][] tint = new int[48][48];
    
    /**
     * assigns the array elements their initial tint values and adds a Num object to the new world (to show world number)
     */
    public Medium0()
    {    
        super(48, 48, 5);
        for (int i=0; i<48; i++) for (int j=0; j<48; j++) tint[i][j]=510-(((int)(Math.hypot(24-i, 24-j)*20))%511);
        addObject(new Num(3), 2, 2);
    }
    
    /**
     * checks mouse clicks (for changing worlds) and keystrokes (for changing speed) and produces wave effect
     */
    public void act()
    {
        // checks for mouse click
        if (Greenfoot.mouseClicked(null)) Greenfoot.setWorld(new Medium1());
        // checks for keystrokes
        String key = Greenfoot.getKey();
        if ("up".equals(key) && freq < 24) freq++;
        if ("down".equals(key) && freq > 1) freq--;
        if (key != null && "1234567".indexOf(key)>-1) color = "1234567".indexOf(key);
        // produce wave effect by constantly changing tint values
        for (int i=0; i<48; i++) for (int j=0; j<48; j++) // for each area
        {
            tint[i][j] = (tint[i][j]+freq)%511; // adjust tint value
            int c = (int)Math.abs(tint[i][j]-255); // get value of color parts
            getBackground().setColor(new Color(c*parts[color][0], c*parts[color][1], c*parts[color][2])); // sets the new drawing color
            getBackground().fillRect(i*5, j*5, 5, 5); // fills the specified area
        }
    }
}