import greenfoot.*;

/**
 * a class used to represent creation of wave pulses using actors and a radial limit
 * 
 * Author: danpost
 * Version: 1.0.0
 */
public class MediumA extends World
{
    /**
     * introduces the actors to a new world with a black background
     * (the black background gives a smoother transition from the faded pulse at the radial limit)
     */
    public MediumA()
    {    
        super(48, 48, 5);
        // make background black
        getBackground().setColor(Color.BLACK);
        getBackground().fill();
        // add the actors to the world
        Drop.setRadius(24);
        for (int i=0; i<48; i++) for (int j=0; j<48; j++) addObject(new Drop(), i, j);
        addObject(new Num(2), 2, 2);
    }
    
    /**
     * checks for mouse clicks (to change worlds) and keystrokes (to change apparent speed and color)
     */
    public void act()
    {
        // check for mouse click
        if (Greenfoot.mouseClicked(null)) Greenfoot.setWorld(new Medium0());
        // check for keystrokes
        String key=Greenfoot.getKey();
        if ("up".equals(key) && Drop.frequency < 24) Drop.frequency++;
        if ("down".equals(key) && Drop.frequency > 1) Drop.frequency--;
        if (key != null && "1234567".indexOf(key) > -1) Drop.setColor("1234567".indexOf(key));
    }
}